﻿using Infragistics.Win;
using Infragistics.Win.Misc;
using Infragistics.Win.UltraWinEditors;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    static class Program
    {
        private static readonly TestingEntity[] _dataSource1 = { new TestingEntity { Name = "First", PropertyId = 1 }, new TestingEntity { Name = "Second", PropertyId = 2 } };
        private static readonly TestingEntity[] _dataSource2 = { new TestingEntity { Name = "Second", PropertyId = 2 } };
        private static readonly TestingEntity _entity = new TestingEntity { PropertyId = 1 };
        private static UltraComboEditor _editor;

        /// <summary>
        /// アプリケーションのメイン エントリ ポイントです。
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);

            using (var bindingSource = new BindingSource())
            {
                using (var form = new Form())
                {
                    bindingSource.DataSource = _entity;
                    _editor = new UltraComboEditor
                    {
                        Dock = DockStyle.Top,
                        DisplayMember = nameof(TestingEntity.Name),
                        ValueMember = nameof(TestingEntity.PropertyId),
                        DropDownStyle = DropDownStyle.DropDownList,
                        DataSource = _dataSource1
                    };
                    _editor.DataBindings.Add(nameof(UltraComboEditor.Value), bindingSource, nameof(TestingEntity.PropertyId), true, DataSourceUpdateMode.OnPropertyChanged);

                    form.Controls.Add(_editor);

                    var button = new UltraButton
                    {
                        Dock = DockStyle.Top
                    };

                    button.Click += ButtonOnClick;
                    form.Controls.Add(button);

                    // Testing code
                    // Binding bindingSource's PropertyId to Label.Text
                    Label label = new Label();
                    label.Dock = DockStyle.Top;
                    label.DataBindings.Add(nameof(Label.Text), bindingSource, nameof(TestingEntity.PropertyId), true, DataSourceUpdateMode.OnPropertyChanged);
                    form.Controls.Add(label);

                    Application.Run(form);
                }
            }
        }

        private static void ButtonOnClick(object sender, EventArgs e)
        {
            /*
            _editor.DataSource = _dataSource2;
            _entity.PropertyId = 2;
            */

            // Testing code
            if(_entity.PropertyId == 1)
            {
                _entity.PropertyId = 2;
            }
            else
            {
                _entity.PropertyId = 1;
            }
        }
    }
}
